package com.smppw.analysis.infrastructure.utils;

import com.smppw.common.pojo.dto.DateValue;
import com.smppw.common.pojo.dto.NavDto;
import com.smppw.common.pojo.enums.NavType;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DateValueUtil {

    public static List<DateValue> convertNavList(List<NavDto> navDtoList, NavType navType) {
        List<DateValue> dateValueList = new ArrayList<>();
        for (NavDto navDto : navDtoList) {
            DateValue dateValue = new DateValue();
            dateValue.setDate(navDto.getPriceDate());
            if (NavType.WithdrawalNav == navType) {
                dateValue.setValue(navDto.getCumulativeNavWithdrawal() != null ? navDto.getCumulativeNavWithdrawal().doubleValue() : null);
            } else if (NavType.OriginalNav == navType) {
                dateValue.setValue(navDto.getOriginalNav() != null ? navDto.getOriginalNav().doubleValue() : null);
            } else if (NavType.All == navType) {
                dateValue.setValue(navDto.getOriginalNav() != null ? navDto.getOriginalNav().doubleValue() : null);
                dateValue.setOriginalNav(navDto.getOriginalNav() != null ? navDto.getOriginalNav() : null);
                dateValue.setCumulativeNav(navDto.getCumulativeNav() != null ? navDto.getCumulativeNav() : null);
                dateValue.setCumulativeNavWithdrawal(navDto.getCumulativeNavWithdrawal() != null ? navDto.getCumulativeNavWithdrawal() : null);
            } else {
                dateValue.setValue(navDto.getCumulativeNav() != null ? navDto.getCumulativeNav().doubleValue() : null);
            }
            dateValueList.add(dateValue);
        }
        return dateValueList;
    }
    public static List<Map<String, Object>> convertDecimalMapToList(Map<String, BigDecimal> originalMap) {
        List<Map<String, Object>> resultList = new ArrayList<>();
        for (Map.Entry<String, BigDecimal> entry : originalMap.entrySet()) {
            String date = entry.getKey();
            Map<String, Object> convertedMap = new HashMap<>();
            convertedMap.put("date", date);
            convertedMap.put("value", entry.getValue());
            resultList.add(convertedMap);
        }
        return resultList;
    }

}
