package com.smppw.analysis.interfaces;

import cn.hutool.core.collection.ListUtil;
import com.smppw.analysis.application.dto.RateRiskIndicatorParams;
import com.smppw.analysis.application.service.PerformanceService;
import com.smppw.common.pojo.enums.Indicator;
import com.smppw.common.pojo.vo.ResultVo;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@RestController
@RequestMapping("/v1/api/fund")
public class FundApi {
    private final PerformanceService performanceService;

    public FundApi(PerformanceService performanceService) {
        this.performanceService = performanceService;
    }

    @GetMapping("/indicators")
    public ResultVo<Map<String, Object>> indicator(RateRiskIndicatorParams params) {
        Map<String, Object> data = this.performanceService.rateRiskIndicators(params, ListUtil.toList(Indicator.INDICATOR_TYPE_ARRAY), ListUtil.toList(Indicator.RISK_TABLE_EXCESS_INDICATOR_ARRAY));
        return ResultVo.ok(data);
    }
}
